require "util"
require "defines"

function get_key_for_invalid( t)
  for k,v in pairs(t) do
    if v.valid==false then return k
    end
    return nil
  end
end

function clean_rctanks()
  local curr = get_key_for_invalid(global.all_rctanks)
  while (curr ~= nil) do
    table.remove(global.all_rctanks, curr)
	curr = get_key_for_invalid(global.all_rctanks, nil)
  end
end

function enter_rctank(key, fromBase)
  game.player.driving = false
  clean_rctanks()
  if global.all_rctanks[key] ~= nil then
    global.rctank_player_x = game.player.character.position.x
    global.rctank_player_y = game.player.character.position.y
    game.player.teleport{global.all_rctanks[key].position.x, global.all_rctanks[key].position.y}
    game.player.driving = true
    global.inrctank = global.all_rctanks[key]
	global.rctank_player_base = fromBase
  else
    game.player.print("No RC tank found")
  end
end

function leave_rctank()
  game.player.driving = false
  global.inrctank = 0
  game.player.teleport{global.rctank_player_x, global.rctank_player_y}
end

function show_rctank_Gui()
-- stub
end

script.on_init(function()
  global.inrctank = 0
  global.rctank_player_x = 0
  global.rctank_player_y = 0
  global.rctank_player_base = 0
  global.all_rctanks = {}
end)

script.on_event(defines.events.on_player_driving_changed_state, function(event)
  if game.player.character and game.player.character.vehicle and game.player.vehicle.name == "rcbase" then
	enter_rctank(1, game.player.character.vehicle)
  else
    if global.inrctank ~= 0 then
	  leave_rctank()
	end
  end
end)

script.on_event(defines.events.on_built_entity, function(event)
  if event.created_entity.name == "rctank" then
    table.insert(global.all_rctanks, event.created_entity)
  end
end)

script.on_event(defines.events.on_entity_died, function(event)
  if event.entity == global.rctank_player_base then
    leave_rctank()
  end
end)